--- kern/vfs_syscalls.c.orig
+++ kern/vfs_syscalls.c
@@ -85,8 +85,10 @@
 static int setfflags(struct thread *td, struct vnode *, int);
 static int setutimes(struct thread *td, struct vnode *,
     const struct timespec *, int, int);
+static int kern_get_at(struct thread *td, int dirfd, struct vnode **dvpp);
 static int vn_access(struct vnode *vp, int user_flags, struct ucred *cred,
     struct thread *td);
+static int kern_absolute_path(const char *path, enum uio_seg pathseg);
 
 /*
  * The module initialization routine for POSIX asynchronous I/O will
@@ -949,14 +951,78 @@
 		int mode;
 	} */ *uap;
 {
+	return kern_open(td, uap->path, UIO_USERSPACE, uap->flags, uap->mode);
+}
 
-	return kern_open(td, uap->path, UIO_USERSPACE, uap->flags, uap->mode);
+#ifndef _SYS_SYSPROTO_H_
+struct openat_args {
+	int	fd;
+	char	*path;
+	int	flag;
+	int	mode;
+};
+#endif
+int
+openat(struct thread *td, struct openat_args *args)
+{
+	return (kern_openat(td, args->fd, args->path, UIO_USERSPACE,
+	   args->flag, args->mode));
 }
 
 int
 kern_open(struct thread *td, char *path, enum uio_seg pathseg, int flags,
     int mode)
 {
+	return (kern_openat(td, AT_FDCWD, (const char *)path, pathseg, flags, mode));
+}
+
+static int
+kern_get_at(struct thread *td, int dirfd, struct vnode **dvpp)
+{
+	int error;
+
+	if (dirfd == AT_FDCWD)
+		*dvpp = NULL;
+	else {
+		error = fgetvp(td, dirfd, dvpp);
+		if (error) {
+		   	*dvpp = NULL;
+			return (error);
+		}
+		if ((*dvpp)->v_type != VDIR) {
+			vrele(*dvpp);
+			*dvpp = NULL;
+			return (ENOTDIR);
+		}
+		if (VFS_NEEDSGIANT((*dvpp)->v_mount))
+			mtx_lock(&Giant);
+	}
+
+	return (0);
+}
+
+/* Check whether a path is an absolute path. */
+static int kern_absolute_path(const char *path, enum uio_seg pathseg)
+{
+	int error;
+	char buf[1];
+
+	if (pathseg == UIO_SYSSPACE) {
+		return (path[0] == '/');		
+	} else {
+		error = copyin(path, buf, 1);
+		if (error)
+			return 0;	/* We want to fail. */
+		return (buf[0] == '/');	
+	}
+}
+
+int
+kern_openat(struct thread *td, int fd, const char *path, enum uio_seg pathseg,
+    int flags, int mode)
+{
+	struct nameidata nd;
+	struct vnode *dvp;
 	struct proc *p = td->td_proc;
 	struct filedesc *fdp = p->p_fd;
 	struct file *fp;
@@ -967,23 +1033,32 @@
 	struct file *nfp;
 	int type, indx, error;
 	struct flock lf;
-	struct nameidata nd;
 	int vfslocked;
 
 	AUDIT_ARG(fflags, flags);
 	AUDIT_ARG(mode, mode);
-	if ((flags & O_ACCMODE) == O_ACCMODE)
-		return (EINVAL);
+	/* XXX: audit dirfd */
+
+	error = kern_get_at(td, fd, &dvp);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | FOLLOW | AUDITVNODE1 |
+	    MPSAFE, pathseg, path, td, dvp);
+
+	if ((flags & O_ACCMODE) == O_ACCMODE) {
+		error = EINVAL;
+		goto out;
+	}
 	flags = FFLAGS(flags);
 	error = falloc(td, &nfp, &indx);
 	if (error)
-		return (error);
+		goto out;
 	/* An extra reference on `nfp' has been held for us by falloc(). */
 	fp = nfp;
 	cmode = ((mode &~ fdp->fd_cmask) & ALLPERMS) &~ S_ISTXT;
-	NDINIT(&nd, LOOKUP, FOLLOW | AUDITVNODE1 | MPSAFE, pathseg, path, td);
 	td->td_dupfd = -1;		/* XXX check for fdopen */
- 	error = vn_open(&nd, &flags, cmode, fp);
+	error = vn_open(&nd, &flags, cmode, fp);
 	if (error) {
 		/*
 		 * If the vn_open replaced the method vector, something
@@ -993,7 +1068,8 @@
 		if (error == ENXIO && fp->f_ops != &badfileops) {
 			fdrop(fp, td);
 			td->td_retval[0] = indx;
-			return (0);
+			error = 0;
+			goto out;
 		}
 
 		/*
@@ -1007,7 +1083,8 @@
 			dupfdopen(td, fdp, indx, td->td_dupfd, flags, error)) == 0) {
 			td->td_retval[0] = indx;
 			fdrop(fp, td);
-			return (0);
+			error = 0;
+			goto out;
 		}
 		/*
 		 * Clean up the descriptor, but only if another thread hadn't
@@ -1018,7 +1095,7 @@
 
 		if (error == ERESTART)
 			error = EINTR;
-		return (error);
+		goto out;
 	}
 	td->td_dupfd = 0;
 	vfslocked = NDHASGIANT(&nd);
@@ -1078,10 +1155,19 @@
 	fdrop(fp, td);
 	td->td_retval[0] = indx;
 	return (0);
+out:
+	if (dvp)
+		vrele(dvp);
+	return (error);
 bad:
 	VFS_UNLOCK_GIANT(vfslocked);
 	fdclose(fdp, fp, indx, td);
 	fdrop(fp, td);
+	if (dvp) {
+		vfslocked = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
 	return (error);
 }
 
@@ -1132,11 +1218,32 @@
 	return (kern_mknod(td, uap->path, UIO_USERSPACE, uap->mode, uap->dev));
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct mknodat_args {
+	char	*path;
+	mode_t	mode;
+	dev_t	dev;
+};
+#endif
 int
+mknodat(struct thread *td, struct mknodat_args *args)
+{
+	return (kern_mknodat(td, args->fd, args->path, UIO_USERSPACE, args->mode,
+	    args->dev));
+}
+
+int
 kern_mknod(struct thread *td, char *path, enum uio_seg pathseg, int mode,
     int dev)
 {
-	struct vnode *vp;
+	return (kern_mknodat(td, AT_FDCWD, (const char *)path, pathseg, mode, dev));
+}
+
+int
+kern_mknodat(struct thread *td, int fd, const char *path, enum uio_seg pathseg,
+    int mode, int dev)
+{
+	struct vnode *vp, *dvp = NULL;
 	struct mount *mp;
 	struct vattr vattr;
 	int error;
@@ -1164,11 +1271,22 @@
 	if (error)
 		return (error);
 restart:
+	if (dvp) {
+		vfslocked = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
+	error = kern_get_at(td, fd, &dvp);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
 	bwillwrite();
-	NDINIT(&nd, CREATE, LOCKPARENT | SAVENAME | MPSAFE | AUDITVNODE1,
-	    pathseg, path, td);
-	if ((error = namei(&nd)) != 0)
+	NDINIT_AT(&nd, CREATE, ((error) ? ATBADF : 0) | LOCKPARENT |
+	    SAVENAME | MPSAFE | AUDITVNODE1, pathseg, path, td, dvp);
+	if ((error = namei(&nd)) != 0) {
+		if (dvp)
+			vrele(dvp);
 		return (error);
+	}
 	vfslocked = NDHASGIANT(&nd);
 	vp = nd.ni_vp;
 	if (vp != NULL) {
@@ -1179,6 +1297,8 @@
 			vput(nd.ni_dvp);
 		vrele(vp);
 		VFS_UNLOCK_GIANT(vfslocked);
+		if (dvp)
+			vrele(dvp);
 		return (EEXIST);
 	} else {
 		VATTR_NULL(&vattr);
@@ -1210,8 +1330,11 @@
 		NDFREE(&nd, NDF_ONLY_PNBUF);
 		vput(nd.ni_dvp);
 		VFS_UNLOCK_GIANT(vfslocked);
-		if ((error = vn_start_write(NULL, &mp, V_XSLEEP | PCATCH)) != 0)
+		if ((error = vn_start_write(NULL, &mp, V_XSLEEP | PCATCH)) != 0) {
+			if (dvp)
+				vrele(dvp);
 			return (error);
+		}
 		goto restart;
 	}
 #ifdef MAC
@@ -1230,6 +1353,11 @@
 				vput(nd.ni_vp);
 		}
 	}
+	if (dvp) {
+		int vfslocked1 = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked1);
+	}
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	vput(nd.ni_dvp);
 	vn_finished_write(mp);
@@ -1258,22 +1386,54 @@
 	return (kern_mkfifo(td, uap->path, UIO_USERSPACE, uap->mode));
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct mkfifoat_args {
+	int	fd;
+	char	*path;
+	mode_t	mode;
+};
+#endif
+int
+mkfifoat(struct thread *td, struct mkfifoat_args *args)
+{
+	return (kern_mkfifoat(td, args->fd, args->path, UIO_USERSPACE, args->mode));
+}
+
 int
 kern_mkfifo(struct thread *td, char *path, enum uio_seg pathseg, int mode)
 {
+	return (kern_mkfifoat(td, AT_FDCWD, (const char *)path, pathseg, mode));
+}
+
+int
+kern_mkfifoat(struct thread *td, int fd, const char *path, enum uio_seg pathseg,
+    int mode)
+{
 	struct mount *mp;
 	struct vattr vattr;
 	int error;
 	struct nameidata nd;
 	int vfslocked;
+	struct vnode *dvp = NULL;
 
 	AUDIT_ARG(mode, mode);
 restart:
+	if (dvp) {
+		vfslocked = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
+	error = kern_get_at(td, fd, &dvp);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
 	bwillwrite();
-	NDINIT(&nd, CREATE, LOCKPARENT | SAVENAME | MPSAFE | AUDITVNODE1,
-	    pathseg, path, td);
-	if ((error = namei(&nd)) != 0)
+	NDINIT_AT(&nd, CREATE, ((error) ? ATBADF : 0) | LOCKPARENT |
+	    SAVENAME | MPSAFE | AUDITVNODE1, pathseg, path, td, dvp);
+	if ((error = namei(&nd)) != 0) {
+		if (dvp)
+			vrele(dvp);
 		return (error);
+	}
 	vfslocked = NDHASGIANT(&nd);
 	if (nd.ni_vp != NULL) {
 		NDFREE(&nd, NDF_ONLY_PNBUF);
@@ -1283,14 +1443,19 @@
 			vput(nd.ni_dvp);
 		vrele(nd.ni_vp);
 		VFS_UNLOCK_GIANT(vfslocked);
+		if (dvp)
+			vrele(dvp);
 		return (EEXIST);
 	}
 	if (vn_start_write(nd.ni_dvp, &mp, V_NOWAIT) != 0) {
 		NDFREE(&nd, NDF_ONLY_PNBUF);
 		vput(nd.ni_dvp);
 		VFS_UNLOCK_GIANT(vfslocked);
-		if ((error = vn_start_write(NULL, &mp, V_XSLEEP | PCATCH)) != 0)
+		if ((error = vn_start_write(NULL, &mp, V_XSLEEP | PCATCH)) != 0) {
+			if (dvp)
+				vrele(dvp);
 			return (error);
+	}
 		goto restart;
 	}
 	VATTR_NULL(&vattr);
@@ -1311,6 +1476,11 @@
 #ifdef MAC
 out:
 #endif
+	if (dvp) {
+		int vfslocked1 = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked1);
+	}
 	vput(nd.ni_dvp);
 	vn_finished_write(mp);
 	VFS_UNLOCK_GIANT(vfslocked);
@@ -1341,6 +1511,29 @@
 	return (error);
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct linkat_args {
+   	int	fd1;
+	char	*path1;
+	int	fd2;
+	char	*path2;
+	int	flag;
+};
+#endif
+int
+linkat(struct thread *td, struct linkat_args *args)
+{
+   	if (args->flag & ~AT_SYMLINK_FOLLOW)
+		return (EINVAL);
+
+	if (args->flag & AT_SYMLINK_FOLLOW)
+		return (kern_linkat(td, args->fd1, args->fd2, args->path1,
+		    args->path2, UIO_USERSPACE, FOLLOW));
+	else
+		return (kern_linkat(td, args->fd1, args->fd2, args->path1,
+		    args->path2, UIO_USERSPACE, 0));
+}
+
 static int hardlink_check_uid = 0;
 SYSCTL_INT(_security_bsd, OID_AUTO, hardlink_check_uid, CTLFLAG_RW,
     &hardlink_check_uid, 0,
@@ -1383,62 +1576,101 @@
 int
 kern_link(struct thread *td, char *path, char *link, enum uio_seg segflg)
 {
+	return (kern_linkat(td, AT_FDCWD, AT_FDCWD, (const char *)path,
+	    (const char *)link, segflg, FOLLOW));
+}
+
+int
+kern_linkat(struct thread *td, int fd1, int fd2, const char *path1, const char *path2,
+    enum uio_seg segflg, int follow)
+{
+	struct nameidata ndp, ndl;
+	struct vnode *pdvp = NULL, *ldvp = NULL;
 	struct vnode *vp;
 	struct mount *mp;
-	struct nameidata nd;
 	int vfslocked;
 	int lvfslocked;
 	int error;
 
+	error = kern_get_at(td, fd1, &pdvp);
+	if (error && !kern_absolute_path(path1, segflg))
+		return (error);
+
+	NDINIT_AT(&ndp, LOOKUP, ((error) ? ATBADF : 0) | follow | MPSAFE |
+	    AUDITVNODE1, segflg, path1, td, pdvp);
+
+	error = kern_get_at(td, fd2, &ldvp);
+	if (error && !kern_absolute_path(path2, segflg)) {
+		if (pdvp) {
+			vfslocked = VFS_NEEDSGIANT(pdvp->v_mount); 
+			vrele(pdvp);
+			VFS_UNLOCK_GIANT(vfslocked);
+		}
+		return (error);
+	}
+
+	NDINIT_AT(&ndl, CREATE, ((error) ? ATBADF : 0) | LOCKPARENT |
+	    SAVENAME | MPSAFE | AUDITVNODE1, segflg, path2, td, ldvp);
+
 	bwillwrite();
-	NDINIT(&nd, LOOKUP, FOLLOW | MPSAFE | AUDITVNODE1, segflg, path, td);
-	if ((error = namei(&nd)) != 0)
-		return (error);
-	vfslocked = NDHASGIANT(&nd);
-	NDFREE(&nd, NDF_ONLY_PNBUF);
-	vp = nd.ni_vp;
+	if ((error = namei(&ndp)) != 0)
+		goto out;
+	vfslocked = NDHASGIANT(&ndp);
+	NDFREE(&ndp, NDF_ONLY_PNBUF);
+	vp = ndp.ni_vp;
 	if (vp->v_type == VDIR) {
 		vrele(vp);
 		VFS_UNLOCK_GIANT(vfslocked);
-		return (EPERM);		/* POSIX */
+		error = EPERM;		/* POSIX */
+		goto out;
 	}
 	if ((error = vn_start_write(vp, &mp, V_WAIT | PCATCH)) != 0) {
 		vrele(vp);
 		VFS_UNLOCK_GIANT(vfslocked);
-		return (error);
+		goto out;
 	}
-	NDINIT(&nd, CREATE, LOCKPARENT | SAVENAME | MPSAFE | AUDITVNODE2,
-	    segflg, link, td);
-	if ((error = namei(&nd)) == 0) {
-		lvfslocked = NDHASGIANT(&nd);
-		if (nd.ni_vp != NULL) {
-			if (nd.ni_dvp == nd.ni_vp)
-				vrele(nd.ni_dvp);
+	if ((error = namei(&ndl)) == 0) {
+		lvfslocked = NDHASGIANT(&ndl);
+		if (ndl.ni_vp != NULL) {
+			if (ndl.ni_dvp == ndl.ni_vp)
+				vrele(ndl.ni_dvp);
 			else
-				vput(nd.ni_dvp);
-			vrele(nd.ni_vp);
+				vput(ndl.ni_dvp);
+			vrele(ndl.ni_vp);
 			error = EEXIST;
 		} else if ((error = vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td))
 		    == 0) {
-			VOP_LEASE(nd.ni_dvp, td, td->td_ucred, LEASE_WRITE);
+			VOP_LEASE(ndl.ni_dvp, td, td->td_ucred, LEASE_WRITE);
 			VOP_LEASE(vp, td, td->td_ucred, LEASE_WRITE);
 			error = can_hardlink(vp, td, td->td_ucred);
 			if (error == 0)
 #ifdef MAC
 				error = mac_check_vnode_link(td->td_ucred,
-				    nd.ni_dvp, vp, &nd.ni_cnd);
+				    ndl.ni_dvp, vp, &ndl.ni_cnd);
 			if (error == 0)
 #endif
-				error = VOP_LINK(nd.ni_dvp, vp, &nd.ni_cnd);
+				error = VOP_LINK(ndl.ni_dvp, vp, &ndl.ni_cnd);
 			VOP_UNLOCK(vp, 0, td);
-			vput(nd.ni_dvp);
+			vput(ndl.ni_dvp);
 		}
-		NDFREE(&nd, NDF_ONLY_PNBUF);
+		NDFREE(&ndl, NDF_ONLY_PNBUF);
 		VFS_UNLOCK_GIANT(lvfslocked);
 	}
 	vrele(vp);
 	vn_finished_write(mp);
 	VFS_UNLOCK_GIANT(vfslocked);
+
+out:
+	if (pdvp) {
+		vfslocked = VFS_NEEDSGIANT(pdvp->v_mount); 
+		vrele(pdvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
+	if (ldvp) {
+		vfslocked = VFS_NEEDSGIANT(ldvp->v_mount); 
+		vrele(ldvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
 	return (error);
 }
 
@@ -1463,28 +1695,58 @@
 	return (kern_symlink(td, uap->path, uap->link, UIO_USERSPACE));
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct symlinkat_args {
+	char	*path;
+	int	fd;
+	char	*path2;
+};
+#endif
 int
+symlinkat(struct thread *td, struct symlinkat_args *args)
+{
+	return (kern_symlinkat(td, args->path1, args->fd, args->path2, UIO_USERSPACE));
+}
+
+int
 kern_symlink(struct thread *td, char *path, char *link, enum uio_seg segflg)
 {
+	return (kern_symlinkat(td, (const char *)path, AT_FDCWD, (const char *)link,
+	    segflg));
+}
+
+int
+kern_symlinkat(struct thread *td, const char *path1, int fd, const char *path2,
+    enum uio_seg segflg)
+{
 	struct mount *mp;
 	struct vattr vattr;
 	char *syspath;
 	int error;
 	struct nameidata nd;
 	int vfslocked;
+	struct vnode *dvp = NULL;
 
 	if (segflg == UIO_SYSSPACE) {
-		syspath = path;
+		syspath = __DECONST(char *, path1);
 	} else {
 		syspath = uma_zalloc(namei_zone, M_WAITOK);
-		if ((error = copyinstr(path, syspath, MAXPATHLEN, NULL)) != 0)
+		if ((error = copyinstr(path1, syspath, MAXPATHLEN, NULL)) != 0)
 			goto out;
 	}
 	AUDIT_ARG(text, syspath);
 restart:
+	if (dvp) {
+		vfslocked = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
+	error = kern_get_at(td, fd, &dvp);
+	if (error && !kern_absolute_path(path2, segflg))
+		return (error);
 	bwillwrite();
-	NDINIT(&nd, CREATE, LOCKPARENT | SAVENAME | MPSAFE | AUDITVNODE1,
-	    segflg, link, td);
+	NDINIT_AT(&nd, CREATE, ((error) ? ATBADF : 0) | LOCKPARENT |
+	    SAVENAME | MPSAFE | AUDITVNODE1, segflg, path2, td, dvp);
 	if ((error = namei(&nd)) != 0)
 		goto out;
 	vfslocked = NDHASGIANT(&nd);
@@ -1530,6 +1792,11 @@
 	vn_finished_write(mp);
 	VFS_UNLOCK_GIANT(vfslocked);
 out:
+	if (dvp) {
+		vfslocked = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
 	if (segflg != UIO_SYSSPACE)
 		uma_zfree(namei_zone, syspath);
 	return (error);
@@ -1608,21 +1875,57 @@
 	return (error);
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct unlinkat_args {
+	int	fd;
+	char	*path;
+	int	flag;
+};
+#endif
+int
+unlinkat(struct thread *td, struct unlinkat_args *args)
+{
+	if (args->flag & ~AT_REMOVEDIR)
+		return (EINVAL);
+
+	if (args->flag & AT_REMOVEDIR)
+		return (kern_rmdirat(td, args->fd, args->path, UIO_USERSPACE));
+	else
+		return (kern_unlinkat(td, args->fd, args->path, UIO_USERSPACE));
+}
+
 int
 kern_unlink(struct thread *td, char *path, enum uio_seg pathseg)
 {
+	return (kern_unlinkat(td, AT_FDCWD, (const char *)path, pathseg));
+}
+
+int
+kern_unlinkat(struct thread *td, int fd, const char *path, enum uio_seg pathseg)
+{
 	struct mount *mp;
-	struct vnode *vp;
+	struct vnode *vp, *dvp = NULL;
 	int error;
 	struct nameidata nd;
 	int vfslocked;
 
 restart:
+	if (dvp) {
+		vfslocked = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
+	error = kern_get_at(td, fd, &dvp);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
 	bwillwrite();
-	NDINIT(&nd, DELETE, LOCKPARENT | LOCKLEAF | MPSAFE | AUDITVNODE1,
-	    pathseg, path, td);
-	if ((error = namei(&nd)) != 0)
+	NDINIT_AT(&nd, DELETE, ((error) ? ATBADF : 0) | LOCKPARENT |
+	    LOCKLEAF | MPSAFE | AUDITVNODE1, pathseg, path, td, dvp);
+	if ((error = namei(&nd)) != 0) {
+		if (dvp)
+			vrele(dvp);		
 		return (error == EINVAL ? EPERM : error);
+	}
 	vfslocked = NDHASGIANT(&nd);
 	vp = nd.ni_vp;
 	if (vp->v_type == VDIR)
@@ -1646,8 +1949,11 @@
 				vput(vp);
 			VFS_UNLOCK_GIANT(vfslocked);
 			if ((error = vn_start_write(NULL, &mp,
-			    V_XSLEEP | PCATCH)) != 0)
+			    V_XSLEEP | PCATCH)) != 0) {
+				if (dvp)
+					vrele(dvp);
 				return (error);
+			}
 			goto restart;
 		}
 #ifdef MAC
@@ -1665,6 +1971,11 @@
 	}
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	vput(nd.ni_dvp);
+	if (dvp) {
+		int vfslocked1 = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked1);
+	}
 	if (vp == nd.ni_dvp)
 		vrele(vp);
 	else
@@ -1861,15 +2172,46 @@
 	return (kern_access(td, uap->path, UIO_USERSPACE, uap->flags));
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct faccessat_args {
+	int	dirfd;
+	char	*path;
+	int	mode;
+	int	flag;
+}
+#endif
+int faccessat(struct thread *td, struct faccessat_args *args)
+{
+	if (args->flag & ~AT_EACCESS)
+		return (EINVAL);
+	/* XXX: what about mode? */
+	return (kern_accessat(td, args->fd, args->path, UIO_USERSPACE, args->flag));
+}
+
 int
 kern_access(struct thread *td, char *path, enum uio_seg pathseg, int flags)
 {
+	return (kern_accessat(td, AT_FDCWD, (const char *)path, pathseg, flags));
+}
+
+int
+kern_accessat(struct thread *td, int fd, const char *path, enum uio_seg pathseg,
+    int flags)
+{
+	struct nameidata nd;
+	struct vnode *dvp;
 	struct ucred *cred, *tmpcred;
-	register struct vnode *vp;
-	struct nameidata nd;
+	struct vnode *vp;
 	int vfslocked;
 	int error;
 
+	error = kern_get_at(td, fd, &dvp);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | FOLLOW | LOCKLEAF |
+	    MPSAFE | AUDITVNODE1, pathseg, path, td, dvp);
+
 	/*
 	 * Create and modify a temporary credential instead of one that
 	 * is potentially shared.  This could also mess up socket
@@ -1877,13 +2219,16 @@
 	 */
 	cred = td->td_ucred;
 	tmpcred = crdup(cred);
-	tmpcred->cr_uid = cred->cr_ruid;
-	tmpcred->cr_groups[0] = cred->cr_rgid;
+	if (flags & AT_EACCESS) {
+		tmpcred->cr_uid = cred->cr_uid;
+		tmpcred->cr_groups[0] = cred->cr_groups[0];
+	} else {
+		tmpcred->cr_uid = cred->cr_ruid;
+		tmpcred->cr_groups[0] = cred->cr_rgid;
+	}
 	td->td_ucred = tmpcred;
-	NDINIT(&nd, LOOKUP, FOLLOW | LOCKLEAF | MPSAFE | AUDITVNODE1,
-	    pathseg, path, td);
 	if ((error = namei(&nd)) != 0)
-		goto out1;
+		goto out;
 	vfslocked = NDHASGIANT(&nd);
 	vp = nd.ni_vp;
 
@@ -1891,9 +2236,14 @@
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	vput(vp);
 	VFS_UNLOCK_GIANT(vfslocked);
-out1:
+out:
 	td->td_ucred = cred;
 	crfree(tmpcred);
+	if (dvp) {
+		vfslocked = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
 	return (error);
 }
 
@@ -2054,18 +2404,50 @@
 	return (error);
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct fstatat_args {
+	int	fd;
+	char	*path;
+	struct stat	*buf;
+	int	flag;
+}
+#endif
+int
+fstatat(struct thread *td, struct fstatat_args *args)
+{
+	if (args->flag & ~AT_SYMLINK_NOFOLLOW)
+		return (EINVAL);
+
+	if (args->flag & AT_SYMLINK_NOFOLLOW)
+		return (kern_lstatat(td, args->fd, args->path, UIO_USERSPACE, args->buf));
+	else
+		return (kern_statat(td, args->fd, args->path, UIO_USERSPACE, args->buf));
+}
+
 int
 kern_stat(struct thread *td, char *path, enum uio_seg pathseg, struct stat *sbp)
 {
+	return (kern_statat(td, AT_FDCWD, (const char *)path, pathseg, sbp));
+}
+
+int
+kern_statat(struct thread *td, int fd, const char *path, enum uio_seg pathseg,
+    struct stat *sbp)
+{
 	struct nameidata nd;
+	struct vnode *dvp;
 	struct stat sb;
 	int error, vfslocked;
 
-	NDINIT(&nd, LOOKUP,
-	    FOLLOW | LOCKSHARED | LOCKLEAF | MPSAFE | AUDITVNODE1,
-	    pathseg, path, td);
+	error = kern_get_at(td, fd, &dvp);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | FOLLOW | LOCKSHARED |
+	    LOCKLEAF | AUDITVNODE1 | MPSAFE, pathseg, path, td, dvp);
+
 	if ((error = namei(&nd)) != 0)
-		return (error);
+		goto out;
 	vfslocked = NDHASGIANT(&nd);
 	error = vn_stat(nd.ni_vp, &sb, td->td_ucred, NOCRED, td);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
@@ -2073,10 +2455,15 @@
 	VFS_UNLOCK_GIANT(vfslocked);
 	if (mtx_owned(&Giant))
 		printf("stat(%d): %s\n", vfslocked, path);
-	if (error)
-		return (error);
-	*sbp = sb;
-	return (0);
+	if (error == 0)
+		*sbp = sb;
+out:	
+	if (dvp) {
+		vfslocked = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
+	return (error);
 }
 
 /*
@@ -2108,26 +2495,42 @@
 int
 kern_lstat(struct thread *td, char *path, enum uio_seg pathseg, struct stat *sbp)
 {
+	return (kern_lstatat(td, AT_FDCWD, (const char *)path, pathseg, sbp));
+}
+
+int
+kern_lstatat(struct thread *td, int fd, const char *path, enum uio_seg pathseg,
+    struct stat *sbp)
+{
+	struct nameidata nd;
+	struct vnode *dvp;
 	struct vnode *vp;
 	struct stat sb;
-	struct nameidata nd;
 	int error, vfslocked;
 
-	NDINIT(&nd, LOOKUP,
-	    NOFOLLOW | LOCKLEAF | LOCKSHARED | MPSAFE | AUDITVNODE1,
-	    pathseg, path, td);
+	error = kern_get_at(td, fd, &dvp);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | NOFOLLOW | LOCKLEAF |
+	    LOCKSHARED | MPSAFE | AUDITVNODE1, pathseg, path, td, dvp);
 	if ((error = namei(&nd)) != 0)
-		return (error);
+		goto out;
 	vfslocked = NDHASGIANT(&nd);
 	vp = nd.ni_vp;
 	error = vn_stat(vp, &sb, td->td_ucred, NOCRED, td);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	vput(vp);
 	VFS_UNLOCK_GIANT(vfslocked);
-	if (error)
-		return (error);
-	*sbp = sb;
-	return (0);
+	if (error == 0)
+		*sbp = sb;
+out:	
+	if (dvp) {
+		vfslocked = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
+	return (error);
 }
 
 /*
@@ -2279,22 +2682,49 @@
 	return (kern_readlink(td, uap->path, UIO_USERSPACE, uap->buf,
 	    UIO_USERSPACE, uap->count));
 }
+#ifndef _SYS_SYSPROTO_H_
+struct readlinkat_args {
+	int	fd;
+	char	*path;
+	char	*buf;
+	size_t	bufsize;
+};
+#endif
+int
+readlinkat(struct thread *td, struct readlinkat_args *args)
+{
+	return (kern_readlinkat(td, args->fd, args->path, UIO_USERSPACE,
+	    args->buf, UIO_USERSPACE, args->bufsize));
+}
 
 int
 kern_readlink(struct thread *td, char *path, enum uio_seg pathseg, char *buf,
     enum uio_seg bufseg, int count)
 {
-	register struct vnode *vp;
+	return (kern_readlinkat(td, AT_FDCWD, (const char *)path, pathseg, buf,
+	    bufseg, count));
+}
+
+int
+kern_readlinkat(struct thread *td, int fd, const char *path, enum uio_seg pathseg,
+    char *buf, enum uio_seg bufseg, int count)
+{
+	struct nameidata nd;
+	struct vnode *dvp;
+	struct vnode *vp;
 	struct iovec aiov;
 	struct uio auio;
-	int error;
-	struct nameidata nd;
-	int vfslocked;
+	int error, vfslocked;
+
+	error = kern_get_at(td, fd, &dvp);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | NOFOLLOW | LOCKLEAF |
+	    MPSAFE | AUDITVNODE1, pathseg, path, td, dvp);
 
-	NDINIT(&nd, LOOKUP, NOFOLLOW | LOCKLEAF | MPSAFE | AUDITVNODE1,
-	    pathseg, path, td);
 	if ((error = namei(&nd)) != 0)
-		return (error);
+		goto out;
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	vfslocked = NDHASGIANT(&nd);
 	vp = nd.ni_vp;
@@ -2303,7 +2733,7 @@
 	if (error) {
 		vput(vp);
 		VFS_UNLOCK_GIANT(vfslocked);
-		return (error);
+		goto out;
 	}
 #endif
 	if (vp->v_type != VLNK)
@@ -2323,6 +2753,12 @@
 	vput(vp);
 	VFS_UNLOCK_GIANT(vfslocked);
 	td->td_retval[0] = count - auio.uio_resid;
+out:
+	if (dvp) {
+		vfslocked = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
 	return (error);
 }
 
@@ -2467,6 +2903,7 @@
 }
 
 /*
+ *
  * Common implementation code for chmod(), lchmod() and fchmod().
  */
 static int
@@ -2516,22 +2953,62 @@
 	return (kern_chmod(td, uap->path, UIO_USERSPACE, uap->mode));
 }
 
+#ifndef _SYS_SYSPROTO_H_
+struct fchmodat_args {
+	int	dirfd;
+	char	*path;
+	mode_t	mode;
+	int	flag;
+}
+#endif
 int
+fchmodat(struct thread *td, struct fchmodat_args *args)
+{
+	if (args->flag & ~AT_SYMLINK_NOFOLLOW)
+		return (EINVAL);
+
+	if (args->flag & AT_SYMLINK_NOFOLLOW)
+		return (kern_lchmodat(td, args->fd, args->path, UIO_USERSPACE,
+		    args->mode));
+	else
+		return (kern_chmodat(td, args->fd, args->path, UIO_USERSPACE,
+		    args->mode));
+}
+
+int
 kern_chmod(struct thread *td, char *path, enum uio_seg pathseg, int mode)
 {
-	int error;
+	return (kern_chmodat(td, AT_FDCWD, (const char *)path, pathseg, mode));
+}
+
+int
+kern_chmodat(struct thread *td, int fd, const char *path, enum uio_seg pathseg,
+    mode_t mode)
+{
 	struct nameidata nd;
-	int vfslocked;
+	struct vnode *dvp;
+	int error, vfslocked;
+
+	error = kern_get_at(td, fd, &dvp);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | FOLLOW | MPSAFE |
+	    AUDITVNODE1, pathseg, path, td, dvp);
 
-	AUDIT_ARG(mode, mode);
-	NDINIT(&nd, LOOKUP, FOLLOW | MPSAFE | AUDITVNODE1, pathseg, path, td);
 	if ((error = namei(&nd)) != 0)
-		return (error);
+		goto out;
 	vfslocked = NDHASGIANT(&nd);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	error = setfmode(td, nd.ni_vp, mode);
 	vrele(nd.ni_vp);
 	VFS_UNLOCK_GIANT(vfslocked);
+out:	
+	if (dvp) {
+		vfslocked = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
 	return (error);
 }
 
@@ -2552,20 +3029,39 @@
 		int mode;
 	} */ *uap;
 {
+	return (kern_lchmodat(td, AT_FDCWD, uap->path, UIO_USERSPACE, uap->mode));
+}
+
+
+int
+kern_lchmodat(struct thread *td, int fd, const char *path, enum uio_seg pathseg,
+    mode_t mode)
+{
 	int error;
 	struct nameidata nd;
 	int vfslocked;
+	struct vnode *dvp;
 
-	AUDIT_ARG(mode, (mode_t)uap->mode);
-	NDINIT(&nd, LOOKUP, NOFOLLOW | MPSAFE | AUDITVNODE1, UIO_USERSPACE,
-	    uap->path, td);
+	error = kern_get_at(td, fd, &dvp);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	AUDIT_ARG(mode, mode);
+	NDINIT_AT(&nd, LOOKUP, NOFOLLOW | MPSAFE | AUDITVNODE1, pathseg,
+	    path, td, dvp);
 	if ((error = namei(&nd)) != 0)
 		return (error);
 	vfslocked = NDHASGIANT(&nd);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
-	error = setfmode(td, nd.ni_vp, uap->mode);
+	error = setfmode(td, nd.ni_vp, mode);
 	vrele(nd.ni_vp);
 	VFS_UNLOCK_GIANT(vfslocked);
+	if (dvp) {
+		vfslocked = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
+
 	return (error);
 }
 
@@ -2661,23 +3157,57 @@
 	return (kern_chown(td, uap->path, UIO_USERSPACE, uap->uid, uap->gid));
 }
 
+#ifndef _SYS_SYSPROTO_H_
+#endif
 int
+fchownat(struct thread *td, struct fchownat_args *args)
+{
+	if (args->flag & ~AT_SYMLINK_NOFOLLOW)
+		return (EINVAL);
+
+	if (args->flag & AT_SYMLINK_NOFOLLOW)
+		return (kern_lchownat(td, args->fd, args->path, UIO_USERSPACE,
+		    args->uid, args->gid));
+	else
+		return (kern_chownat(td, args->fd, args->path, UIO_USERSPACE,
+		    args->uid, args->gid));
+}
+
+int
 kern_chown(struct thread *td, char *path, enum uio_seg pathseg, int uid,
     int gid)
 {
-	int error;
+	return (kern_chownat(td, AT_FDCWD, (const char *)path, pathseg, uid, gid));
+}
+
+int
+kern_chownat(struct thread *td, int fd, const char *path, enum uio_seg pathseg,
+    int uid, int gid)
+{
 	struct nameidata nd;
-	int vfslocked;
+	struct vnode *dvp;
+	int error, vfslocked;
+
+	error = kern_get_at(td, fd, &dvp);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | FOLLOW | MPSAFE |
+	    AUDITVNODE1, pathseg, path, td, dvp);
 
-	AUDIT_ARG(owner, uid, gid);
-	NDINIT(&nd, LOOKUP, FOLLOW | MPSAFE | AUDITVNODE1, pathseg, path, td);
 	if ((error = namei(&nd)) != 0)
-		return (error);
+		goto out;
 	vfslocked = NDHASGIANT(&nd);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	error = setfown(td, nd.ni_vp, uid, gid);
 	vrele(nd.ni_vp);
 	VFS_UNLOCK_GIANT(vfslocked);
+out:	
+	if (dvp) {
+		vfslocked = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
 	return (error);
 }
 
@@ -2708,19 +3238,37 @@
 kern_lchown(struct thread *td, char *path, enum uio_seg pathseg, int uid,
     int gid)
 {
-	int error;
+	return (kern_lchownat(td, AT_FDCWD, (const char *)path, pathseg, uid, gid));
+}
+
+int
+kern_lchownat(struct thread *td, int fd, const char *path, enum uio_seg pathseg,
+    int uid, int gid)
+{
 	struct nameidata nd;
-	int vfslocked;
+	struct vnode *dvp;
+	int error, vfslocked;
+
+	error = kern_get_at(td, fd, &dvp);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | NOFOLLOW | MPSAFE |
+	    AUDITVNODE1, pathseg, path, td, dvp);
 
-	AUDIT_ARG(owner, uid, gid);
-	NDINIT(&nd, LOOKUP, NOFOLLOW | MPSAFE | AUDITVNODE1, pathseg, path, td);
 	if ((error = namei(&nd)) != 0)
-		return (error);
+		goto out;
 	vfslocked = NDHASGIANT(&nd);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	error = setfown(td, nd.ni_vp, uid, gid);
 	vrele(nd.ni_vp);
 	VFS_UNLOCK_GIANT(vfslocked);
+out:	
+	if (dvp) {
+		vfslocked = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
 	return (error);
 }
 
@@ -2863,25 +3411,54 @@
 	    UIO_USERSPACE));
 }
 
+#ifndef _SYS_SYSPROTO_H_
+#endif
+int
+futimesat(struct thread *td, struct futimesat_args *args)
+{
+	return (kern_utimesat(td, args->fd, args->path, UIO_USERSPACE,
+	    args->times, UIO_USERSPACE));
+}
+
 int
 kern_utimes(struct thread *td, char *path, enum uio_seg pathseg,
     struct timeval *tptr, enum uio_seg tptrseg)
 {
+	return (kern_utimesat(td, AT_FDCWD, (const char *)path, pathseg,
+	    (const struct timeval *)tptr, tptrseg));
+}
+
+int
+kern_utimesat(struct thread *td, int fd, const char *path, enum uio_seg pathseg,
+    const struct timeval *tptr, enum uio_seg tptrseg)
+{
+	struct nameidata nd;
+	struct vnode *dvp;
 	struct timespec ts[2];
-	int error;
-	struct nameidata nd;
-	int vfslocked;
+	int error, vfslocked;
+
+   	error = kern_get_at(td, fd, &dvp);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
+
+	NDINIT_AT(&nd, LOOKUP, ((error) ? ATBADF : 0) | FOLLOW | MPSAFE |
+	    AUDITVNODE1, pathseg, path, td, dvp);
 
 	if ((error = getutimes(tptr, tptrseg, ts)) != 0)
-		return (error);
-	NDINIT(&nd, LOOKUP, FOLLOW | MPSAFE | AUDITVNODE1, pathseg, path, td);
+		goto out;
 	if ((error = namei(&nd)) != 0)
-		return (error);
+		goto out;
 	vfslocked = NDHASGIANT(&nd);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	error = setutimes(td, nd.ni_vp, ts, 2, tptr == NULL);
 	vrele(nd.ni_vp);
 	VFS_UNLOCK_GIANT(vfslocked);
+out:
+	if (dvp) {
+		vfslocked = VFS_NEEDSGIANT(dvp->v_mount); 
+		vrele(dvp);
+		VFS_UNLOCK_GIANT(vfslocked);
+	}
 	return (error);
 }
 
